<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/area.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>area.c</h1><a href="area_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: area.c 2992 2010-03-10 21:57:41Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="util_8h.html#ae10b3dfec502fed986fa89fea83631f9">00029</a> <span class="keywordtype">int</span> <a class="code" href="area_8c.html#ae10b3dfec502fed986fa89fea83631f9">AreaCal</a>(Mat AIpol, PetscReal *p_area)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   PetscReal area;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <span class="keywordtype">int</span> ngrows,ngcols;
<a name="l00034"></a>00034   <span class="keywordtype">int</span> nlrows,nlcols;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   Vec       test1,test2;
<a name="l00037"></a>00037   PetscReal vmin,vmax;
<a name="l00038"></a>00038   <span class="keywordtype">int</span>       imin,imax;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   ierr = MatGetSize(AIpol,&amp;ngrows,&amp;ngcols);CHKERRQ(ierr);
<a name="l00043"></a>00043   ierr = MatGetLocalSize(AIpol,&amp;nlrows,&amp;nlcols);CHKERRQ(ierr);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   ierr = VecCreate(PETSC_COMM_WORLD,&amp;test1);CHKERRQ(ierr);
<a name="l00046"></a>00046   ierr = VecCreate(PETSC_COMM_WORLD,&amp;test2);CHKERRQ(ierr);
<a name="l00047"></a>00047   ierr = VecSetSizes(test1,nlcols,ngcols);CHKERRQ(ierr);
<a name="l00048"></a>00048   ierr = VecSetSizes(test2,nlrows,ngrows);CHKERRQ(ierr);
<a name="l00049"></a>00049   ierr = VecSetFromOptions(test1);CHKERRQ(ierr);
<a name="l00050"></a>00050   ierr = VecSetFromOptions(test2);CHKERRQ(ierr);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   ierr = VecSet(test1,1.0);CHKERRQ(ierr);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   ierr = MatMult(AIpol,test1,test2);CHKERRQ(ierr);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">/* check result of interpolation */</span>
<a name="l00057"></a>00057   ierr = VecMin(test2,&amp;imin,&amp;vmin);CHKERRQ(ierr);
<a name="l00058"></a>00058   ierr = VecMax(test2,&amp;imax,&amp;vmax);CHKERRQ(ierr);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (vmin&lt;0.0 || vmax&gt;1.0+<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00061"></a>00061     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00062"></a>00062       <span class="stringliteral">&quot;need to rescale matrix: %i: %e  %i: %e\n&quot;</span>,
<a name="l00063"></a>00063       imin,vmin,imax,vmax
<a name="l00064"></a>00064     );
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="comment">/* TODO: rescale AIpol (not sure why this is necessary)</span>
<a name="l00067"></a>00067 <span class="comment">       seems like some pixels belong to two elements (just on interface!?)</span>
<a name="l00068"></a>00068 <span class="comment">    */</span>
<a name="l00069"></a>00069     PetscReal *atest2;
<a name="l00070"></a>00070     ierr = VecGetArray(test2,&amp;atest2);CHKERRQ(ierr);
<a name="l00071"></a>00071     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;nlrows;i++) {
<a name="l00072"></a>00072       <span class="keywordflow">if</span> (atest2[i]&gt;1.0) atest2[i]=1.0/atest2[i];
<a name="l00073"></a>00073     }
<a name="l00074"></a>00074     ierr = VecRestoreArray(test2,&amp;atest2);CHKERRQ(ierr);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     ierr = MatDiagonalScale(AIpol,test2,PETSC_NULL);CHKERRQ(ierr);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078     ierr = MatMult(AIpol,test1,test2);CHKERRQ(ierr);
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">/* double check result of interpolation */</span>
<a name="l00082"></a>00082   ierr = VecMin(test2,&amp;imin,&amp;vmin);CHKERRQ(ierr);
<a name="l00083"></a>00083   ierr = VecMax(test2,&amp;imax,&amp;vmax);CHKERRQ(ierr);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00086"></a>00086     <span class="stringliteral">&quot;min/max: %i: %e  %i: %e\n&quot;</span>,
<a name="l00087"></a>00087     imin,vmin,imax,vmax
<a name="l00088"></a>00088   );
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   assert(vmin&gt;=0.0);
<a name="l00091"></a>00091   assert(vmax&lt;=1.0+<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">/* area calculation */</span>
<a name="l00094"></a>00094   ierr = VecSum(test2,&amp;area);CHKERRQ(ierr);
<a name="l00095"></a>00095   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;area = %g/%i=%g%%\n&quot;</span>,area,ngrows,area/ngrows*100);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   *p_area=area;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   ierr = VecDestroy(test1);
<a name="l00100"></a>00100   ierr = VecDestroy(test2);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">/* FIXME</span>
<a name="l00107"></a>00107 <span class="comment"> * save elevertall in griddata.h during initialization</span>
<a name="l00108"></a>00108 <span class="comment"> * save/use connectivity matrices:</span>
<a name="l00109"></a>00109 <span class="comment"> *   elements sharing faces</span>
<a name="l00110"></a>00110 <span class="comment"> *   elements sharing nodes</span>
<a name="l00111"></a>00111 <span class="comment"> *   nodes connected by edges</span>
<a name="l00112"></a>00112 <span class="comment"> */</span>
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="util_8h.html#ad881c6e71023a337d9a87f59d207106c">00114</a> <span class="keywordtype">int</span> <a class="code" href="area_8c.html#ad881c6e71023a337d9a87f59d207106c">PidSharedArea</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,<span class="keywordtype">int</span> pid1,<span class="keywordtype">int</span> pid2,PetscReal *sharedarea_area,PetscReal *sharedarea_point,PetscReal *sharedarea_norm)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordtype">int</span> rank,size;
<a name="l00119"></a>00119   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00120"></a>00120   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keywordflow">if</span> (pid1==pid2)
<a name="l00123"></a>00123     SETERRQ2(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;Pids have to be different to calculate shared area (%i==%i)!\n&quot;</span>,pid1+1,pid2+1);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="keywordflow">if</span> (pid1&gt;=gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>)
<a name="l00126"></a>00126     SETERRQ2(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;pid1 too large (%i&gt;%i)!\n&quot;</span>,pid1+1,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>);
<a name="l00127"></a>00127   <span class="keywordflow">if</span> (pid2&gt;=gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>)
<a name="l00128"></a>00128     SETERRQ2(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;pid2 too large (%i&gt;%i)!\n&quot;</span>,pid1+1,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>);
<a name="l00129"></a>00129   <span class="keywordflow">if</span> (pid1&lt;=-1 &amp;&amp; pid2&lt;=-1)
<a name="l00130"></a>00130     SETERRQ2(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;pids too small (%i,%i)&lt;1!\n&quot;</span>,pid1+1,pid2+1);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Search shared area for pids %i, %i\n&quot;</span>,pid1+1,pid2+1);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">/* get ownership range */</span>
<a name="l00135"></a>00135   <span class="keywordtype">int</span> low,high;
<a name="l00136"></a>00136   ierr = VecGetOwnershipRange(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;low,&amp;high);CHKERRQ(ierr);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordtype">int</span> *elevertall;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#ifdef HAVE_ELEVERTALL</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>  elevertall=gdata-&gt;elevertall;
<a name="l00142"></a>00142 <span class="preprocessor">#else</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00144"></a>00144     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;elevertall);CHKERRQ(ierr);
<a name="l00145"></a>00145     ierr = PetscMemcpy(elevertall+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*low,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="keywordtype">int</span> *p;
<a name="l00148"></a>00148     p=elevertall;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150     <span class="keywordtype">int</span> recvcount[size];
<a name="l00151"></a>00151     recvcount[rank]=<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;
<a name="l00152"></a>00152     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;size;i++) {
<a name="l00153"></a>00153       ierr = MPI_Bcast(recvcount+i,1,MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00154"></a>00154       <span class="comment">/* we could also use MPI_Send/Recv to get everything just to the first processor */</span>
<a name="l00155"></a>00155       ierr = MPI_Bcast(p,recvcount[i],MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00156"></a>00156       p+=recvcount[i];
<a name="l00157"></a>00157     }
<a name="l00158"></a>00158     assert(p==elevertall+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00159"></a>00159   }
<a name="l00160"></a>00160   <span class="keywordflow">else</span> {
<a name="l00161"></a>00161     elevertall=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>;
<a name="l00162"></a>00162   }
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>
<a name="l00165"></a>00165   <span class="keywordtype">int</span> *elepropall;
<a name="l00166"></a>00166   <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00167"></a>00167     ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;elepropall);CHKERRQ(ierr);
<a name="l00168"></a>00168     ierr = PetscMemcpy(elepropall+low,gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170     <span class="keywordtype">int</span> *p;
<a name="l00171"></a>00171     p=elepropall;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     <span class="keywordtype">int</span> recvcount[size];
<a name="l00174"></a>00174     recvcount[rank]=gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;
<a name="l00175"></a>00175     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;size;i++) {
<a name="l00176"></a>00176       ierr = MPI_Bcast(recvcount+i,1,MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178       ierr = MPI_Bcast(p,recvcount[i],MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00179"></a>00179       p+=recvcount[i];
<a name="l00180"></a>00180     }
<a name="l00181"></a>00181     assert(p==elepropall+gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183   <span class="keywordflow">else</span> {
<a name="l00184"></a>00184     elepropall=gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>;
<a name="l00185"></a>00185   }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="keywordtype">int</span> *elevertcoupled;
<a name="l00188"></a>00188   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;elevertcoupled);CHKERRQ(ierr);
<a name="l00189"></a>00189   ierr = PetscMemcpy(elevertcoupled,elevertall,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="preprocessor">#ifndef HAVE_ELEVERTALL</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00193"></a>00193     ierr = PetscFree(elevertall);CHKERRQ(ierr);
<a name="l00194"></a>00194   }
<a name="l00195"></a>00195 <span class="preprocessor">#endif</span>
<a name="l00196"></a>00196 <span class="preprocessor"></span>
<a name="l00197"></a>00197   PetscReal sarea_area;
<a name="l00198"></a>00198   sarea_area=0;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   PetscReal sarea_point[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00201"></a>00201   PetscReal sarea_norm[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00202"></a>00202   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00203"></a>00203     sarea_point[i]=sarea_norm[i]=0.0;
<a name="l00204"></a>00204   }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="comment">/* only first processor does everything */</span>
<a name="l00207"></a>00207   <span class="keywordflow">if</span> (!rank) {
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>    <span class="comment">/* map all coupled vertices to common vertex (lowest id) */</span>
<a name="l00211"></a>00211     <span class="keywordflow">if</span> (gdata-&gt;vertcoupl!=PETSC_NULL) {
<a name="l00212"></a>00212       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00213"></a>00213         <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[elevertcoupled[i]]&gt;=0 &amp;&amp;
<a name="l00214"></a>00214             gdata-&gt;vertcoupl[elevertcoupled[i]]&lt;elevertcoupled[i]) {
<a name="l00215"></a>00215           elevertcoupled[i]=gdata-&gt;vertcoupl[elevertcoupled[i]];
<a name="l00216"></a>00216         }
<a name="l00217"></a>00217       }
<a name="l00218"></a>00218     }
<a name="l00219"></a>00219 <span class="preprocessor">#endif</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span>
<a name="l00221"></a>00221     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating mesh connectivity\n&quot;</span>);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223     <span class="keywordtype">int</span> *ia,*ja;
<a name="l00224"></a>00224     ierr = <a class="code" href="mesh2dual_8c.html#a072403ed5e4bbd16fd845d52009d1270">Mesh2Dual</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,elevertcoupled,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>+1;i++) {
<a name="l00227"></a>00227       <span class="keywordflow">if</span> (ia[i]-ia[i-1]&gt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) {
<a name="l00228"></a>00228         SETERRQ2(PETSC_ERR_MEMC,<span class="stringliteral">&quot;Found element with %i neighbors (&gt;NF)!\n&quot;</span>,ia[i]-ia[i-1],<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>);
<a name="l00229"></a>00229       }
<a name="l00230"></a>00230     }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="comment">/* check for array overrun */</span>
<a name="l00233"></a>00233     assert(ia[gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>]&lt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Searching shared faces\n&quot;</span>);
<a name="l00236"></a>00236     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++) {
<a name="l00237"></a>00237       <span class="keywordflow">if</span> (elepropall[i]!=pid1) <span class="keywordflow">continue</span>;
<a name="l00238"></a>00238 
<a name="l00239"></a>00239       <span class="keywordflow">if</span> (pid2&gt;=0) {
<a name="l00240"></a>00240         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j2=ia[i];j2&lt;ia[i+1];j2++) {
<a name="l00241"></a>00241           <span class="keywordtype">int</span> j;
<a name="l00242"></a>00242           j=ja[j2];
<a name="l00243"></a>00243 
<a name="l00244"></a>00244           <span class="keywordflow">if</span> (elepropall[j]!=pid2) <span class="keywordflow">continue</span>;
<a name="l00245"></a>00245 
<a name="l00246"></a>00246           <span class="keywordtype">int</span> s[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>-1];
<a name="l00247"></a>00247           <span class="keywordtype">int</span> k;
<a name="l00248"></a>00248           k=<a class="code" href="tettri_8c.html#a62d7f69412ba9d0be81b6d815062456b">TetSharedVertices</a>(elevertcoupled+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i,elevertcoupled+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*j,s);
<a name="l00249"></a>00249           assert(k==<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>-1);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251           PetscReal a;
<a name="l00252"></a>00252           PetscReal n[ND];
<a name="l00253"></a>00253           a=<a class="code" href="tettri_8c.html#a3ea39ff11354754297822b91f4922d52">triarea</a>(
<a name="l00254"></a>00254             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+ND*s[0],
<a name="l00255"></a>00255             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+ND*s[1],
<a name="l00256"></a>00256             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+ND*s[2],
<a name="l00257"></a>00257             n
<a name="l00258"></a>00258           );
<a name="l00259"></a>00259 
<a name="l00260"></a>00260           sarea_area+=a;
<a name="l00261"></a>00261 
<a name="l00262"></a>00262           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> p=0;p&lt;ND;p++) {
<a name="l00263"></a>00263             <span class="keywordflow">if</span> (n[2]&gt;=0.0) {
<a name="l00264"></a>00264               sarea_norm[p]+=n[p]*a;
<a name="l00265"></a>00265             }
<a name="l00266"></a>00266             <span class="keywordflow">else</span> {
<a name="l00267"></a>00267               sarea_norm[p]-=n[p]*a;
<a name="l00268"></a>00268             }
<a name="l00269"></a>00269             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> q=0;q&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>-1;q++) {
<a name="l00270"></a>00270               sarea_point[p]+=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*s[q]+p]*a/(NV-1.0);
<a name="l00271"></a>00271             }
<a name="l00272"></a>00272           }
<a name="l00273"></a>00273         }
<a name="l00274"></a>00274       }
<a name="l00275"></a>00275       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (pid2==-1) {
<a name="l00276"></a>00276         <span class="comment">/* total surface of vol with pid1: complicated to implement (see facnb.c) */</span>
<a name="l00277"></a>00277         SETERRQ1(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;Program branch for pid2==%i not implemented!\n&quot;</span>,pid2);
<a name="l00278"></a>00278       }
<a name="l00279"></a>00279       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (pid2==-2) {
<a name="l00280"></a>00280         <span class="comment">/* free surface of vol with pid1: complicated to implement (see facnb.c) */</span>
<a name="l00281"></a>00281         SETERRQ1(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;Program branch for pid2==%i not implemented!\n&quot;</span>,pid2);
<a name="l00282"></a>00282       }
<a name="l00283"></a>00283     }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     ierr = PetscFree(ia);CHKERRQ(ierr);
<a name="l00286"></a>00286     ierr = PetscFree(ja);CHKERRQ(ierr);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   ierr = MPI_Bcast(&amp;sarea_area,1,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00291"></a>00291   ierr = MPI_Bcast(sarea_point,ND,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00292"></a>00292   ierr = MPI_Bcast(sarea_norm,ND,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00295"></a>00295     ierr = PetscFree(elepropall);CHKERRQ(ierr);
<a name="l00296"></a>00296   }
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   *sharedarea_area=sarea_area;
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="keywordflow">if</span> (sharedarea_point!=PETSC_NULL) {
<a name="l00301"></a>00301     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(ND,1.0/sarea_area,sarea_point,1);
<a name="l00302"></a>00302     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,sarea_point,1,sharedarea_point,1);
<a name="l00303"></a>00303   }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="keywordflow">if</span> (sharedarea_norm!=PETSC_NULL) {
<a name="l00306"></a>00306     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(ND,1.0/sarea_area,sarea_norm,1);
<a name="l00307"></a>00307     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,sarea_norm,1,sharedarea_norm,1);
<a name="l00308"></a>00308   }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

